/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or ;use
** Qt Designer which will update this file, preservi your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
void kmpBackend::init() {
    
    this->hide();
    //Set the current playlist at 0 (updates on connect)
    curPlaylist = 0;
    //Set the initial Connection to NULL
    conn = NULL;
    atStatus=FALSE;
    random = FALSE;
    repeat = FALSE;
    showFilenameOnly = FALSE;
    showSplash = TRUE;
    showMiniW = FALSE;
    refreshInt=150;
    skipServerStatusUpdate = 0;
    lastDb = 0;
    showGUI = TRUE;    
    plDl = 0;
    streamUpdate = FALSE;
    
    //***********************************WINDOW CREATION*****************************
    playlistWindow = new kmpPlaylist(this);
    //Connect the increment playlist signal call to the increment playlist
    // function on the main window
    connect(playlistWindow, SIGNAL(incrementPlaylist()), this, SLOT(incrementPlaylist()));
    connect(playlistWindow, SIGNAL(decrementPlaylist()), this, SLOT(decrementPlaylist()));
    //Connect the playlist closed signal call to the playlistClosed slot on
    // main window
    connect(playlistWindow, SIGNAL(playlistClosed()), this, SLOT(playlistClosed()));
    //Connect the playlist connError signal call to the connError stlot on
    // main window
    connect(playlistWindow, SIGNAL(connError()), this, SLOT(connError()));
    //And connect the playlist windows pause status and unpause status functions to the main windows
    connect(playlistWindow, SIGNAL(pauseStatus()), this, SLOT(pauseStatus()));
    connect(playlistWindow, SIGNAL(unpauseStatus()), this, SLOT(unpauseStatus())); 
    //And the playlist or the browse window isn't open yet
    playlistShown=FALSE;
    browseShown=FALSE;
    //**************************
    
    //**Browse Window Creation **
    //Create a new browse window
    browseWindow = new kmpBrowse;
    //Connect the browse closed signal call to the browseClosed slot on
    // main window
    connect(browseWindow, SIGNAL(browseClosed()), this, SLOT(browseClosed()));
    connect(browseWindow, SIGNAL(connError()), this, SLOT(connError()));
    //**************************
    
    //**************dragNdrop****************
    //This section we give our children each other, so they can
    //Directly talk to each other :)
    playlistWindow->setBrowse(browseWindow);
    //**********************************
    
    //**Connect Window Creation **
    //Create a new connect window
    connectWindow = new kmpConnect(this);
    connect(connectWindow, SIGNAL( returnStatus(int, mpd_Connection*&, QString, int, QString) ), this, SLOT(returnStatus(int, mpd_Connection *&, QString, int, QString)) );
    //**************************
    
    //**Misc Window Creation **
    
    //Create a new options window
    optionsWindow = new kmpOptions(this);
    connect(optionsWindow, SIGNAL(returnSettings(bool, bool, bool, bool, QColor, QColor , int , int,bool, int, int) ) , this, SLOT(returnSettings( bool , bool, bool, bool, QColor , QColor , int, int,bool, int, int )));
    
    //Create a new about window
    aboutWindow = new kmpAbout(this);
    //**************************
  
    //**************************************GUI CREATION******************************
    
    //MAIN WINDOW
    mainWindow = new kmpMain(this);
    connect(mainWindow, SIGNAL(toggleRepeat()), this, SLOT(toggleRepeat()));
    connect(mainWindow, SIGNAL(toggleRandom()), this, SLOT(toggleRandom()));    
    connect(mainWindow, SIGNAL(toggleBrowse()), this, SLOT(toggleBrowse()));    
    connect(mainWindow, SIGNAL(togglePlaylist()), this, SLOT(togglePlaylist()));    
    connect(mainWindow, SIGNAL(showAbout()), this, SLOT(showAbout()));    
    connect(mainWindow, SIGNAL(showOptions()), this, SLOT(showOptions()));    
    connect(mainWindow, SIGNAL(showConnect()), this, SLOT(showConnect()));    
    connect(mainWindow, SIGNAL(sendVolume(int)), this, SLOT(sendVolume(int)));    
    connect(mainWindow, SIGNAL(sendSeek(double)), this, SLOT(sendSeek(double)));    
    connect(mainWindow, SIGNAL(sendNext()), this, SLOT(sendNext()));    
    connect(mainWindow, SIGNAL(sendPrev()), this, SLOT(sendPrev()));    
    connect(mainWindow, SIGNAL(sendPlay()), this, SLOT(sendPlay()));    
    connect(mainWindow, SIGNAL(sendStop()), this, SLOT(sendStop()));    
    connect(mainWindow, SIGNAL(closed()), this, SLOT(mainClosed()));
    connect(mainWindow, SIGNAL(kill()), this, SLOT(kill()));
    connect(mainWindow, SIGNAL(toggleWindow()), this, SLOT(toggleWindow()));
    
    
    //MINI WINDOW
    miniWindow = new kmpMini(this);    
    connect(miniWindow, SIGNAL(toggleRepeat()), this, SLOT(toggleRepeat()));
    connect(miniWindow, SIGNAL(toggleRandom()), this, SLOT(toggleRandom()));    
    connect(miniWindow, SIGNAL(toggleBrowse()), this, SLOT(toggleBrowse()));    
    connect(miniWindow, SIGNAL(togglePlaylist()), this, SLOT(togglePlaylist()));    
    connect(miniWindow, SIGNAL(showAbout()), this, SLOT(showAbout()));    
    connect(miniWindow, SIGNAL(showOptions()), this, SLOT(showOptions()));    
    connect(miniWindow, SIGNAL(showConnect()), this, SLOT(showConnect()));    
    //connect(miniWindow, SIGNAL(sendVolume(int)), this, SLOT(sendVolume(int)));    
    connect(miniWindow, SIGNAL(sendSeek(double)), this, SLOT(sendSeek(double)));    
    connect(miniWindow, SIGNAL(sendNext()), this, SLOT(sendNext()));    
    connect(miniWindow, SIGNAL(sendPrev()), this, SLOT(sendPrev()));    
    connect(miniWindow, SIGNAL(sendPlay()), this, SLOT(sendPlay()));    
    connect(miniWindow, SIGNAL(sendStop()), this, SLOT(sendStop()));    
    connect(miniWindow, SIGNAL(closed()), this, SLOT(miniClosed()));
    connect(miniWindow, SIGNAL(kill()), this, SLOT(kill()));
    connect(miniWindow, SIGNAL(toggleWindow()), this, SLOT(toggleWindow()));
    
    
    //NOTIFICATION WINDOW
    notifyWindow = new kmpNotify(0,0, Qt::WStyle_Customize | Qt::WStyle_NoBorder | Qt::WStyle_StaysOnTop | Qt::WX11BypassWM);
    
    
    
    //TRAY ICON
    
    //Load Icons    
    icons * MyIcons;
    MyIcons = new icons;
    tray = MyIcons->trayI;
    trayPlay = MyIcons->trayPlayI;
    trayPause = MyIcons->trayPauseI;
    trayStop = MyIcons->trayStopI;
    playI = MyIcons->playI;
    pauseI = MyIcons->pauseI;    
    
    //Make Menus...    
    popupMenu = new QPopupMenu();
    popupMenu->setCheckable(FALSE);    
    //Commands in this Menu
    commandMenu = new QPopupMenu();
    commandMenu->setCheckable(TRUE);    
    commandMenu->insertItem(playI, "Play", this, SLOT(sendPlay()));
    commandMenu->insertItem(MyIcons->stopI, "Stop", this, SLOT(sendStop()));
    commandMenu->insertItem(MyIcons->nextI, "Next", this, SLOT(sendNext()));
    commandMenu->insertItem(MyIcons->prevI, "Prev", this, SLOT(sendPrev()));
    commandMenu->insertItem("Random", this, SLOT(toggleRandom()));
    commandMenu->insertItem("Repeat", this, SLOT(toggleRepeat()));
    connect(commandMenu, SIGNAL(aboutToShow()), this, SLOT(fixCommand()));    
    //Windows in this Menu
    windowMenu = new QPopupMenu();
    windowMenu->setCheckable(TRUE);    
    windowMenu->insertItem("Main", this, SLOT(toggleMain()));
    windowMenu->insertItem("Mini UI", this, SLOT(toggleMini()));
    windowMenu->insertItem(MyIcons->playlistI, "Playlist", this, SLOT(togglePlaylist()));
    windowMenu->insertItem(MyIcons->browseI, "Browse", this, SLOT(toggleBrowse()));
    windowMenu->insertItem("Options", this, SLOT(showOptions()));
    //Quit Double Check Menu
    QPopupMenu * quitMenu = new QPopupMenu();
    quitMenu->setCheckable(FALSE);    
    quitMenu->insertItem("Quit KMP", this, SLOT(kill()));
    //Main Menu
    popupMenu->insertItem("Connect", this, SLOT(showConnect()));
    popupMenu->insertItem("About", this, SLOT(showAbout()));
    popupMenu->insertItem("Quit  ", quitMenu);
    popupMenu->insertItem("Windows  ", windowMenu);
    popupMenu->insertItem("Commands  ", commandMenu);
    

   
    theTray = new TrayIcon(tray, "Disconnected...", popupMenu, this, "kmpTray");
    connect(theTray, SIGNAL(clicked( const QPoint&, int)), this, SLOT(trayClicked( const QPoint&, int)));
    connect(theTray, SIGNAL(doubleClicked( const QPoint& )), this, SLOT(openGUI(            )));

    //*********************************************************************************
    

    mainWindow->postStatusBar("Not Connected");

    
    
    
     //******* TIMER CREATION *********
    //The following section is for creating timers (in essence seperate threads)
    //Which are currently: mainStatusLoop, and scrollLoop
       
    
    //*****mainStatusLoop*****
    //Create the Timer
    statusLoop = new QTimer(this);
    //Connect the timer timeout, to the statusloop slot 
    //This is basically updating the status in a seperate process
    connect(statusLoop, SIGNAL(timeout()), this, SLOT(statusCheck()));
    //************************
    
    //******reconnectLoop*****
    //Create the Timer
    reconnectLoop = new QTimer(this);
    //Connect the timer timeout to the reconnect Slot
    connect(reconnectLoop, SIGNAL(timeout()), this, SLOT(serverReconnect()));
    //***********************
    

    
     //**********************************
    //**************LOAD SAVED SETTINGS!
    loadSettings();
    
    if(showSplash)
    {
        QRect dt;
        QDesktopWidget desktop;
        dt = desktop.screenGeometry();    
        dt = desktop.screenGeometry(); 
        dt = desktop.screenGeometry(); 
        this->move(dt.width()/2 - width()/2, dt.height()/2 - height()/2);
 this->clearWFlags(Qt::WType_Dialog | Qt::WStyle_NormalBorder | Qt::WStyle_DialogBorder | Qt::WStyle_Title | Qt::WStyle_SysMenu);
 this->setWFlags(Qt::WStyle_Customize | Qt::WStyle_NoBorder);
 this->update();
 this->repaint();
 this->show();
 QTimer::singleShot(3000, this, SLOT(hideSplash()) );
    }
    
    if(useTray) theTray->show();     
    
    if(noneOpen) return;
    
    if(showMiniW) {
 toggleMini();
    } else {
 toggleMain();
    }
    
}

//Name: hideSplash()
//When&What Calls: This is called after 5 secs of seeing the splash, or the user clicks on it
//Purpose:  To hide the splash Screen
void kmpBackend::hideSplash()
{
    this->hide();
}
//Name: openConnect()
//When&What Calls:  When user opens the connect dialog
//Purpose:  To show the window, and update the windows connection parameters
void kmpBackend::openConnect()
{
    //Set the windows "Connection"
    connectWindow-> setConn(conn);
    //Show the window
    connectWindow -> show();
}

//Name:  returnStatus
//When&What Calls:  This is returned by the connection window
//Purpose:  To update the main windows connections, open and close connections
// other then the statusConnection (done by connectionWindow) and change
// the status of the client look (What buttons you can use ect...)
void kmpBackend::returnStatus(int status, mpd_Connection *& conn_, QString ServerName, int ServerPort, QString ServerPassword)
{
    
    conn = conn_;
    //Set the Tray Commands to there respective Enabled
    commandMenu->setItemEnabled(commandMenu->idAt(0), status);
    commandMenu->setItemEnabled(commandMenu->idAt(1), status);
    commandMenu->setItemEnabled(commandMenu->idAt(2), status);
    commandMenu->setItemEnabled(commandMenu->idAt(3), status);    
    commandMenu->setItemEnabled(commandMenu->idAt(4), status);
    commandMenu->setItemEnabled(commandMenu->idAt(5), status);        
    if(status) {
 mainWindow->postStatusBar("Connected...");
 //We stop trying to reconnect if we are....
 reconnectLoop->stop();
 //Store the status
 serverStatus = MPD_STATUS_STATE_STOP;
 //Re-Intialize Variables so that the a) playlist updates and b)Current song is Updated
 curSong = -1;
 curPlaylist = -1;
 //Save the server information (So we can open up additional Connections)
 serverName = ServerName;
 serverPort = ServerPort;
 serverPassword = ServerPassword;
 //Give the playlist window the connection
 playlistWindow->setConn(conn);
 //Give the browse window the server information (So it can open up its own connection
 browseWindow->serverInfo(ServerName, ServerPort, ServerPassword);
 
 //*************PlaylistDownloader**********
 if(plDl) {
     plDl->wait(10000);
     delete plDl;
     plDl = 0;
 }
     plDl = new dlPlaylist(playlistWindow, ServerName, ServerPort, ServerPassword);
    //****************************************
 unpauseStatus();
 
 mainWindow->changeStatus(status);
 miniWindow->changeStatus(status);
 playlistWindow->enableMe(status);
 browseWindow->enableMe(status);
 theTray->setIcon(trayStop);
 theTray->setToolTip("Stopped.");

    } else {
 statusLoop->stop();
 
 if(plDl) {
     plDl->wait(10000);
     delete plDl;
     plDl = 0;
 }
 
 //*** This is when the connection has been closed ***
 //First close all the connections.
 if(conn != NULL) mpd_closeConnection(conn);
 conn = NULL;    //Command Connection to null
 browseWindow->closeConnection(); //Tell the browse window to close its connection
 
 mainWindow->changeStatus(status);
 miniWindow->changeStatus(status);
 playlistWindow->enableMe(status);
 browseWindow->enableMe(status);
 theTray->setIcon(tray);
 theTray->setToolTip("Disconnected...");


    }
    
}

//Name:  StatusLoop
//When&What Calls: This is called by the statusTimer 
//Purpose:  To get the status from the server and update the client
void kmpBackend::statusCheck()
{
    atStatus = TRUE;
    //First off if the main connection is closed, we can't update!
    // So we just retun
    checkForErrors(conn);
    if(conn==NULL) { atStatus = FALSE; return;}
    if(((double) (skipServerStatusUpdate++) * ((double) refreshInt / 1000.0f)) > 5) {
        streamUpdate = TRUE;
        skipServerStatusUpdate = 0;
        //Every 10 seconds update server status
        mpd_Stats * stats;
        mpd_sendStatsCommand(conn);        
        checkForErrors(conn);
        if(conn==NULL) { atStatus = FALSE; return;}
     
        if(conn==NULL) { atStatus = FALSE; return;}
        if((stats = mpd_getStats(conn)) == NULL) {
            checkForErrors(conn);
            atStatus = FALSE;
            return;
        }
        QString version = QString::number(conn->version[0]) + "." + QString::number(conn->version[1]) + "." + QString::number(conn->version[2]);
        QString playTime = longTime(stats->playTime);
        QString upTime = longTime(stats->uptime);
        QString dbTime = ctime((time_t *) (&stats->dbUpdateTime));
        if(lastDb != stats->dbUpdateTime)
        {
            lastDb = stats->dbUpdateTime;
            browseWindow->refreshView();
        }

        optionsWindow->setServerStats(version, playTime, upTime, dbTime, stats->numberOfArtists, stats->numberOfAlbums, stats->numberOfSongs);
        
        mpd_freeStats(stats);
        checkForErrors(conn);
        if(conn==NULL) { atStatus = FALSE; return;}
    }
    mpd_sendStatusCommand(conn);
    //Next we create a variable to hold the status of the server
    mpd_Status * status;
    //Then if there is nothing in the status,  there is an error!
    if((status = mpd_getStatus(conn))==NULL) {
        checkForErrors(conn);
        atStatus = FALSE;
        return;
    }
    
    //If the server does not have volume support, (unsupported mixer)
    // we disable the volume bar
    if(status->volume == MPD_STATUS_NO_VOLUME) {
 if(!volDisabled) {
     
     mainWindow->setVolDisabled(true);
     volDisabled = true;
 }
    } else {
 if(volDisabled) {
     
     mainWindow->setVolDisabled(false);
     volDisabled = false;
 }
 //If we do have volume support, update the volume.
 if(curVolume != (100 - status->volume)) {
     curVolume = (100 - status->volume);
     
 mainWindow->setVolume(curVolume);
    }
    //Next we check to see if the playlist in the server is different then
    // what we think it is (CurPlaylist is incremented every time
    // WE change the playlist, so if the server playlist has been
    // updated more times then WE have changed it, we need to
    // get the new playlist)
    if(curPlaylist < status->playlist) {
 //We are now getting the new playlist, so store the new number
 curPlaylist = status->playlist;
 mainWindow->postStatusBar("Updating Playlist");
 //Next we do a single shot timer (bascially spawn another
 // process) to update the playlist. We do this here
 // so all updates to the playlist are done in the
 // background,  So there is no waiting to download
 // the playlist when you open the playlist window!
 QTimer::singleShot( 50, this, SLOT(updatePlaylist()));
    }
    //&&& Crossfade
    optionsWindow->setCrossfade(status->crossfade);
    
    
    
    if(random != status->random) {
 random = !random;
 
 mainWindow->setRandom(random);
 miniWindow->setRandom(random);
 commandMenu->setItemChecked(commandMenu->idAt(4), random);
 
    }
    if(repeat != status->repeat) {
 repeat = !repeat;
 
 mainWindow->setRepeat(repeat);
 miniWindow->setRepeat(repeat);
 commandMenu->setItemChecked(commandMenu->idAt(5), repeat);
    }
    
    //If the server is playing a song (or paused for that matter) We have alot more things to update
    if(status->state == MPD_STATUS_STATE_PLAY || status->state == MPD_STATUS_STATE_PAUSE){
 if(status->state == MPD_STATUS_STATE_PLAY) {
     if(theTray->icon().serialNumber() != trayPlay.serialNumber() ) theTray->setIcon(trayPlay);
 } else {
     if(theTray->icon().serialNumber() != trayPause.serialNumber()) theTray->setIcon(trayPause);
 }

 //We need to create some variables to hold the current song
 // elapsed and total time. We store it in doubles so
 // when we divide the two, we get a ratio, not a int.
 int elapsedTime = status->elapsedTime;
 curSongLen = status->totalTime;
 int bitrate = status->bitRate;
 
 mainWindow->update(elapsedTime, bitrate);
 miniWindow->update(elapsedTime);
 theTray->setToolTip(tooltip(curSongStore, elapsedTime));
 
 //We need to tell the playlist window which song is playing so
 // it somehow highlights it.
 playlistWindow->songPlaying(status->song);
 //Now we check to see if the current song playing is the song that WAS
 // playing. (So when a new song plays we update information)
 if(curSong != status->song || streamUpdate)  {
     //If we have a new song, we need to get the new song information.
     //So we create a entity to hold the information
     mpd_InfoEntity * entity;
     //And ask the server the information for this song number
     // using the COMMAND pipe.
     mpd_sendPlaylistInfoCommand(conn,status->song);
     //And of course check for errors in the process
     checkForErrors(conn);
     //Then we process the information
     while((entity = mpd_getNextInfoEntity(conn))) {
  //If for some really wierd reason the information comming in the
  // pipe isn't a song, we skip it, and hope we get what we
  // want. This should NEVER happen, but b.s.t.s.
  if(entity->type!=MPD_INFO_ENTITY_TYPE_SONG) {
      mpd_freeInfoEntity(entity);
      continue;
  }
  //****************
  //Then we create a new storable song (non pointers used)
  mpd_SongStore aSong;
  //And set all of the information to it.
  aSong.file = QString::fromUtf8(entity->info.song->file);
  aSong.artist = QString::fromUtf8(entity->info.song->artist);
  aSong.album = QString::fromUtf8(entity->info.song->album);
  aSong.title = QString::fromUtf8(entity->info.song->title);
  aSong.track = QString::fromUtf8(entity->info.song->track);
  aSong.time = entity->info.song->time;
  //Then we update the Main bar's text using the title sub-function.
  curSongStore = aSong;
  if((streamUpdate && currentName != title(aSong) ) || !streamUpdate) {
          mainWindow->newSong(aSong);
          miniWindow->newSong(aSong);
          if(useNotify) {
              notifyWindow->setNotify(aSong.title, aSong.artist , aSong.album);
              notifyWindow->showIt(notifyCorner, notifyTime*1000);
          }
      }
  currentName = title(aSong);
  
  //Now we release the memory that we used to get this new song's info
  mpd_freeInfoEntity(entity);
  //And we again check for errors. Just in case :-P
  checkForErrors(conn);
  if(conn==NULL) { atStatus = FALSE; return;}
     }
     //Now that we have the new song's information we store that.
     curSong = status->song;
     //And we finish the last command given (playlist info)
     mpd_finishCommand(conn);
     //And check for errors!
     checkForErrors(conn);
    if(conn==NULL) { atStatus = FALSE; return;}     
 }

 //&&&&&&&&&&&&&&&&&&&&&&&CREATE POPUP INFO&&&&&&&&&&&&&&&&&&&
 
 
    //If the server is stopped, and the main bar has some text in it we change it to none
    // This only happens when this is the first update after a stop.
       } else if (status->state == MPD_STATUS_STATE_STOP) {
    serverStatus = status->state;
    mainWindow->changeStatus(status->state);
    miniWindow->changeStatus(status->state);
    playlistWindow->enableMe(status->state);
    browseWindow->enableMe(status->state);
    theTray->setIcon(trayStop);
    theTray->setToolTip("Stopped.");
    curSong = -1;

       }
    //Then we make SURE that we are currently at the same state as the server
    // If it changed somewhere along the way, we update the interface
       
   mainWindow->changeStatus(status->state);
   miniWindow->changeStatus(status->state);
   playlistWindow->enableMe(status->state);
   browseWindow->enableMe(status->state);
    //Set the Tray Commands to there respective Enabled
    commandMenu->setItemEnabled(commandMenu->idAt(0), status->state);
    commandMenu->setItemEnabled(commandMenu->idAt(1), status->state);
    commandMenu->setItemEnabled(commandMenu->idAt(2), status->state);
    commandMenu->setItemEnabled(commandMenu->idAt(3), status->state);     
    commandMenu->setItemEnabled(commandMenu->idAt(4), status->state);
    commandMenu->setItemEnabled(commandMenu->idAt(5), status->state);     
    
    serverStatus = status->state;
    //Then we have to relase the memory holding the current status
    mpd_freeStatus(status);
    //And again check for errors!
    checkForErrors(conn);
    atStatus = FALSE;
    }
}
    
    
//Name:  sendStop
//When&What Calls:  the Stop button
//Purpose:   To send a stop command to the server
void kmpBackend::sendStop()
{
    //During any commands sent through the pipe we have to pause the status update
    // So we don't do 2 things at once :)
    pauseStatus();
    //If the player is ALREADY stopped, just return, the user is an idiot.
    if(serverStatus == MPD_STATUS_STATE_STOP) {
 unpauseStatus();
 return;
    }
    //If not we send the stop command.
    mpd_sendStopCommand(conn);
    //And check for errors of course
    checkForErrors(conn);
    //Then this command waits for the response from the server (To stop mis-
    // communication through the pipe)
    mpd_finishCommand(conn);
    //And check for errors again
    checkForErrors(conn);
    unpauseStatus();
}

//Name:  sendPlay
//When&What Calls:  the play/pause button
//Purpose:  to either send a play or pause command
void kmpBackend::sendPlay()
{
    //During any commands sent through the pipe we have to pause the status update
    // So we don't do 2 things at once :)
    pauseStatus();
    if(serverStatus == MPD_STATUS_STATE_PLAY) {
 //If we are currently playing, send a pause
 mpd_sendPauseCommand(conn, 1);
    } else if (serverStatus == MPD_STATUS_STATE_PAUSE) {
 //If we are currently paused, send a play
 mpd_sendPauseCommand(conn, 0);
    } else {
 //If we are currently stopped, then play from the beginning
 mpd_sendPlayCommand(conn, MPD_PLAY_AT_BEGINNING);
    }
    //And check for errors    
    checkForErrors(conn);
    //Then this command waits for the response from the server (To stop mis-
    // communication through the pipe)
    mpd_finishCommand(conn);
    //And check for errors again
    checkForErrors(conn);
    unpauseStatus();
}

//Name:  sendPrev
//When&What Calls:  the previous button
//Purpose:  to send a previous command to the server
void kmpBackend::sendPrev()
{
    //During any commands sent through the pipe we have to pause the status update
    // So we don't do 2 things at once :)
    pauseStatus();
    //send the previous command to the server
    mpd_sendPrevCommand(conn);
    //And check for errors
    checkForErrors(conn);
    //Then this command waits for the response from the server (To stop mis-
    // communication through the pipe)
    mpd_finishCommand(conn);
    //And check for errors
    checkForErrors(conn);
    unpauseStatus();
}

//Name:  sendNext
//When&What Calls:  
//Purpose:  to send a next command to the server
void kmpBackend::sendNext()
{
    //During any commands sent through the pipe we have to pause the status update
    // So we don't do 2 things at once :)
    pauseStatus();
    //send the next command to the server
    mpd_sendNextCommand(conn);
    //And check for errors
    checkForErrors(conn);
    //Then this command waits for the response from the server (To stop mis-
    // communication through the pipe)
    mpd_finishCommand(conn);
    //And check for errors    
    checkForErrors(conn);
    unpauseStatus();
}

//Name:  sendSeek
//When&What Calls:  
//Purpose:  to send a next command to the server
void kmpBackend::sendSeek(double percent)
{
    //During any commands sent through the pipe we have to pause the status update
    // So we don't do 2 things at once :)
    pauseStatus();
    //send the next command to the server
    mpd_sendSeekCommand(conn, curSong, (int)(percent*curSongLen));
    //And check for errors
    checkForErrors(conn);
    //Then this command waits for the response from the server (To stop mis-
    // communication through the pipe)
    mpd_finishCommand(conn);
    //And check for errors    
    checkForErrors(conn);
    unpauseStatus();
}
//Name:  sendVol
//When&What Calls:  
//Purpose:  to send a next command to the server
void kmpBackend::sendVolume(int volume)
{
    //During any commands sent through the pipe we have to pause the status update
    // So we don't do 2 things at once :)
    pauseStatus();
    //send the next command to the server
    mpd_sendVolumeCommand(conn, curVolume - volume);
    //And check for errors
    checkForErrors(conn);
    //Then this command waits for the response from the server (To stop mis-
    // communication through the pipe)
    mpd_finishCommand(conn);
    //And check for errors    
    checkForErrors(conn);
    unpauseStatus();
}
//Name:  checkForErrors
//When&What Calls:  this is called a BAZILLION TIMES
//Purpose:  To check to see if there is any errors in the connection
//  we call this ALOT of times, because it doesn't
//  hurt to check, and its VERY usefull to check,
//  as this stops the client from crashing!
void kmpBackend::checkForErrors(mpd_Connection *& conn_)
{
    //If this connection does NOT exist, we try to reconnect
    if(conn_ == NULL) {
 atStatus = FALSE;
 returnStatus(0, conn_, serverName, serverPort, serverPassword);
 reconnectLoop->start(3000);
 return;
    }
    //If there IS an error then we do some checks
    if(conn_->error) {
 //We create a string variable to hold the error
 QString Error;
 //And get the error
 Error = QString(conn_->errorStr);
 if(conn_->error == MPD_ERROR_ACK) {
     //If the error is just an acknoledgement, (NON FATAL)
     // we just put it in the status bar for the user to see
     if(Error.contains("permission")) {
  QString myMessage = "You do not have Permission to ";
  QString theError = Error.right(Error.length() - Error.findRev('"', -2) - 1);
  theError = theError.left(theError.length() - 1);
  printf("*%s*\n", theError.ascii());
  if(theError == "play" || theError == "stop" || theError == "next" || theError == "previous" ||
     theError == "pause") {
      myMessage += "control playing.";
  }
  myMessage += "\n\nYou must reconnect to the server with a different\n"
   "password if you wish to continue.\n\n";
  QMessageBox::warning( this, "KMP", myMessage,"Ok", 0, 0, 0, 1 )  ;
     }
     //PASS ERROR TO CHILDREN&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
     //statusBar()->message(Error.right(Error.length()-4));
     //And clear the error so that everything will work correctly
     mpd_clearError(conn_);
     return;
 }
 //If we got here, then the error was fatal.... which is bad. So we disconnect.
 // gracefully of course :-p
 mpd_clearError(conn_);
 //And we close the connection
 //mpd_closeConnection(conn_);
 //And set it to NULL
 conn_ =NULL;
 returnStatus(0, conn_, serverName, serverPort, serverPassword); 
 //If the connection has been closed we have to reset the entire client...
 //And now we try to reconnect to the server every 3 seconds
 atStatus = FALSE;
 QTimer::singleShot( 1, this, SLOT(serverReconnect()) );
 reconnectLoop->start(3000);
    }
}
//Name:  updatePlaylist
//When&What Calls:  This is called by the status checks when the playlist has changed
//Purpose:  To open a new connection download the new playlist, and then close that
// additional connection. We decided to open another connection for this, as if
// you are on a slow connection and have a huge playlist on a host far away, this
// downloading of the playlist could take a significant amount of time. Which could
// both a) slow down the client and b) hog up the pipe.   Since we don't want either of
// these things to happen we open a connection dedicated to updating the playlist
void kmpBackend::updatePlaylist()
{
    if(!plDl) return;
     if(plDl->running()) {
      plDl->terminate();
        plDl->wait(100);
    }
    playlistWindow->playlistDownload();
    plDl->start(QThread::NormalPriority);
    //PASS NEW PLAYLIST UPDATE TO CHILDREN&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
    //mainWindow->postStatusBar("Playlist Updated: " + QTime::currentTime().toString());
    //curSong = -1;
}
//Name:  closeEvent
//When&What Calls: This is called when the main window has closed 
//Purpose:  At the moment it closes all of the windows, and de-allocates
//  all memory that we have allocated
void kmpBackend::closeEvent( QCloseEvent * a) {
    //We close our two connections in this window
    if(conn != NULL) mpd_closeConnection(conn);
    conn = NULL;   //Main Connection
    browseWindow->closeConnection(); //Tell the browse window to close its connection
    //Save Settings
    saveSettings();
    //Tell the other windows to close
    playlistWindow->close();
    connectWindow->close();
    browseWindow->close();
    optionsWindow->close();
    aboutWindow->close();
    mainWindow->close();
    miniWindow->close();
    //Delete the windows memory
    delete connectWindow;
    delete playlistWindow;
    //De-allocate memory for the linked list
    ServerList.reset();

    //And accept the close event
    Shutdown();
    a->accept();   
}
//Name:  showPlaylist
//When&What Calls: Playlist Button, or Menu Item
//Purpose:  To show/close the playlist window
void kmpBackend::togglePlaylist()
{
    //First we check to see if its already open, if so we close it
    if(playlistShown)  {
 playlistWindow->close();
 playlistShown=FALSE;
    } else {
 //If its not open we show it, and then store that its open
 playlistWindow->show();
 playlistShown = TRUE;
    }
    mainWindow->setPlaylistVis(playlistShown);
    miniWindow->setPlaylistVis(playlistShown);
    windowMenu->setItemChecked(windowMenu->idAt(2), playlistShown);
    
}

//Name:  showBrowse
//When&What Calls: Browse Button, or Menu Item
//Purpose:  To show/close the Browse window
void kmpBackend::toggleBrowse()
{
    //First we check to see if its already open, if so we close it
    if(browseShown)  {
 browseWindow->close();
 browseShown=FALSE;
    } else {
 //If its not open we show it, and then store that its open
 browseWindow->show();
 browseShown = TRUE;
    }
    mainWindow->setBrowseVis(browseShown);
    miniWindow->setBrowseVis(browseShown);
    windowMenu->setItemChecked(windowMenu->idAt(3), browseShown);
}
//Name:  playlistClosed
//When&What Calls:  this is called by the playlistwindow when it closes
//Purpose:  To make sure the playlist button is un pressed and menu item unchecked
void kmpBackend::playlistClosed()
{
    //Store that the window is closed
    playlistShown = FALSE;
    mainWindow->setPlaylistVis(playlistShown);
    miniWindow->setPlaylistVis(playlistShown);
    windowMenu->setItemChecked(windowMenu->idAt(2), playlistShown);

}

//Name:  browseClosed
//When&What Calls:  this is called by the browse window when it closes
//Purpose:  To make sure the browse button is un pressed and menu item unchecked
void kmpBackend::browseClosed()
{

    //Store that the window is closed
    browseShown = FALSE;
    mainWindow->setBrowseVis(browseShown);
    miniWindow->setBrowseVis(browseShown);
    windowMenu->setItemChecked(windowMenu->idAt(3), browseShown);    
}

//Name:  increment playlist
//When&What Calls:  this is called by the playlist window
//Purpose:  to increment the internal playlist. So we don't update the playlist
//  we do ANYTHING to the playlist
void kmpBackend::incrementPlaylist()
{
    curPlaylist++;
}
//Name:  connError
//When&What Calls: this is called when any child window has connection problems  
//Purpose:  to close all the connections and start a reconnect
void kmpBackend::connError()
{
    returnStatus(0, conn, serverName, serverPort, serverPassword);
    //And now we try to reconnect to the server every 3 seconds
    mainWindow->postStatusBar("Disconnected...");
    theTray->setIcon(tray);
    theTray->setToolTip("Disconnected...");
    QTimer::singleShot( 1, this, SLOT(serverReconnect()) );
    reconnectLoop->start(3000);
}
//Name:  serverReconnect
//When&What Calls:  this is called by the reconnect loop
//Purpose:  to reconnect kmp to the server
void kmpBackend::serverReconnect()
{
    if(conn != NULL) {
 mpd_closeConnection(conn);
 conn = NULL;
    }
    if(serverName == "") { 
 reconnectLoop->stop();
 return;
    }
    
    mainWindow->postStatusBar("Disconnected... Reconnecting");
    theTray->setToolTip("Disconnected... Reconnecting");
    conn = mpd_newConnection(serverName, serverPort,1);
    //Check to see if it succesfully connected
    if(serverPassword != "") {
 mpd_sendPasswordCommand(conn, serverPassword);
 mpd_finishCommand(conn);
    }
    if(conn->error) {
 //If we didn't close the connection and get ready to connect again
 mpd_closeConnection(conn);
 conn = NULL;
    } else { 
 //Otherwise return that we have connected
 returnStatus(1, conn, serverName, serverPort, serverPassword);
    }
}

//Name:   pauseStatus
//When&What Calls:  Called before any function that uses command pipe
//Purpose:  to stop 2 commands at once
void kmpBackend::pauseStatus()
{
    while(atStatus) {}
    statusLoop->stop();
}

//Name:  unpauseStatus
//When&What Calls:  after a command is issued
//Purpose: Lets the status continue updating 
void kmpBackend::unpauseStatus()
{
    statusLoop->start(refreshInt);
}

//Name:  showOptions
//When&What Calls:  called to show the options window
//Purpose:  to show the options window
void kmpBackend::showOptions()
{
    optionsWindow->show();
}

//Name:  showAbout
//When&What Calls: called by guis 
//Purpose:  to show the about window
void kmpBackend::showAbout()
{
    aboutWindow->show();
}
//Name:  showAbout
//When&What Calls: called by guis 
//Purpose:  to show the about window
void kmpBackend::showConnect()
{
    connectWindow->show();
}
//Name:  toggleRandom
//When&What Calls: called by guis 
//Purpose:  to toggle random
void kmpBackend::toggleRandom()
{
    if(!conn) return;
    pauseStatus();
    mpd_sendRandomCommand(conn, !random);
    checkForErrors(conn);
    mpd_finishCommand(conn);
    checkForErrors(conn);
    random = !random;
    
    mainWindow->setRandom(random);
    miniWindow->setRandom(random);
    commandMenu->setItemChecked(commandMenu->idAt(4), random);
    
    unpauseStatus();
}

//Name:  toggleRepeat
//When&What Calls: called by guis 
//Purpose:  to toggle repeat
void kmpBackend::toggleRepeat()
{
    if(!conn) return;
    pauseStatus();
    mpd_sendRepeatCommand(conn, !repeat);
    checkForErrors(conn);
    mpd_finishCommand(conn);
    checkForErrors(conn);
    repeat = !repeat;
    
    mainWindow->setRepeat(repeat);
    miniWindow->setRepeat(repeat);
    commandMenu->setItemChecked(commandMenu->idAt(5), repeat);
    
    unpauseStatus();
}


  void kmpBackend::returnSettings( bool useFilename, bool showSplash_, bool showStatus_, bool useTray_, QColor LCDbg_, QColor LCDfg_, int refreshRate ,int crossFade, bool useNotify_, int notifyCorner_, int notifyTime_)
{
    if(showFilenameOnly != useFilename) {
 showFilenameOnly = useFilename;
 mainWindow->setFilenameOnly(useFilename);
 miniWindow->setFilenameOnly(useFilename);
 playlistWindow->showFilename(useFilename);
 curSong = -1;
 curPlaylist = -1;
    }
    useNotify = useNotify_;
    notifyCorner = notifyCorner_;
    notifyTime = notifyTime_;
    mainWindow->setColors(LCDbg_, LCDfg_);
    refreshInt = refreshRate;
    showSplash = showSplash_;
    useTray = useTray_;
    if(!useTray) {
 noneOpen = !(miniWindow->isShown() || mainWindow->isShown());
 theTray->hide();
 if(!noneOpen) return;
 if(showMiniW) {
     toggleMini();
 } else {
     toggleMain();
 }
    } else {
 theTray->show();
    }
    
    mainWindow->setStatusbar(showStatus_);
    if(statusLoop->isActive()) {
 pauseStatus();
 mpd_sendCrossfadeCommand(conn, crossFade);
 checkForErrors(conn);
 if(conn == NULL) return;
 mpd_finishCommand(conn);
 checkForErrors(conn);
 unpauseStatus();
    }
}


void kmpBackend::saveSettings()
{
    QSettings settings;
    QString APP_KEY = "/kmp/";
    int r,b,g;
    noneOpen = !(miniWindow->isShown() || mainWindow->isShown());
    //Backend Settings
    settings.writeEntry( APP_KEY + "RefreshRate", refreshInt);
    settings.writeEntry( APP_KEY + "ShowFilename", showFilenameOnly);    
    settings.writeEntry( APP_KEY + "ShowSplash", showSplash);    
    settings.writeEntry( APP_KEY + "UseTray", useTray);    
    settings.writeEntry( APP_KEY + "MiniUI", showMiniW);    
    settings.writeEntry( APP_KEY + "NoUI", noneOpen);
    settings.writeEntry( APP_KEY + "UseNotify", useNotify);
    settings.writeEntry( APP_KEY + "NotifyLocation", notifyCorner);
    settings.writeEntry( APP_KEY + "NotifyTimeout", notifyTime);
    //Main Window Settings
    settings.writeEntry( APP_KEY + "MainWindowX", mainWindow->x() );
    settings.writeEntry( APP_KEY + "MainWindowY", mainWindow->y() );
    mainWindow->getBgColors(r,g,b);
    settings.writeEntry( APP_KEY + "LCDbgR", r);
    settings.writeEntry( APP_KEY + "LCDbgG", g);
    settings.writeEntry( APP_KEY + "LCDbgB", b);
    mainWindow->getFgColors(r,g,b);
    settings.writeEntry( APP_KEY + "LCDfgR", r);
    settings.writeEntry( APP_KEY + "LCDfgG", g);
    settings.writeEntry( APP_KEY + "LCDfgB", b);
    settings.writeEntry( APP_KEY + "NegativeTime", mainWindow->getNegTime());
    settings.writeEntry( APP_KEY + "ShowStatus", mainWindow->getStatusVis());
    //Mini Window Settings
    settings.writeEntry( APP_KEY + "MiniWindowX", miniWindow->x() );
    settings.writeEntry( APP_KEY + "MiniWindowY", miniWindow->y() );
    settings.writeEntry( APP_KEY + "MiniWindowWidth", miniWindow->width() );    
    //Connect Window Settings
    QString ACname = connectWindow->ACname;
    QString ACpassword = connectWindow->ACpassword;
    int ACport = connectWindow->ACport;
    QStringList theList (connectWindow->stored);
    settings.writeEntry( APP_KEY + "ServerAutoName", ACname);
    settings.writeEntry( APP_KEY + "ServerAutoPort", ACport);
    settings.writeEntry( APP_KEY + "ServerAutoPassword", ACpassword);
    settings.writeEntry( APP_KEY + "ServerList", theList);
    
    //PlaylistWindow
    settings.writeEntry( APP_KEY + "PLWindowX", playlistWindow->x() );
    settings.writeEntry( APP_KEY + "PLWindowY", playlistWindow->y() );
    settings.writeEntry( APP_KEY + "PLWindowWidth", playlistWindow->width() );
    settings.writeEntry( APP_KEY + "PLWindowHeight", playlistWindow->height() );
    
    //BrowseWindow
    settings.writeEntry( APP_KEY + "BRWindowX", browseWindow->x() );
    settings.writeEntry( APP_KEY + "BRWindowY", browseWindow->y() );
    settings.writeEntry( APP_KEY + "BRWindowWidth", browseWindow->width() );
    settings.writeEntry( APP_KEY + "BRWindowHeight", browseWindow->height() );
    settings.writeEntry( APP_KEY + "StreamLib", browseWindow->getStreams());                         
}

void kmpBackend::loadSettings()
{
    QSettings settings;
    QString APP_KEY = "/kmp/";
    int r,b,g,x,y,w,h;
    QColor bg, fg;
    bool negTime;
    bool showStatus;
    //Backend Settings
    
    refreshInt = settings.readNumEntry( APP_KEY + "RefreshRate", 150 );
    showFilenameOnly = settings.readBoolEntry( APP_KEY + "ShowFilename", FALSE );
    showSplash = settings.readBoolEntry( APP_KEY + "ShowSplash", TRUE );
    showMiniW = settings.readBoolEntry( APP_KEY + "MiniUI", FALSE );
    noneOpen = settings.readBoolEntry(APP_KEY + "NoUI", FALSE);
    useTray = settings.readBoolEntry( APP_KEY + "UseTray", TRUE );
    useNotify = settings.readBoolEntry( APP_KEY + "UseNotify", FALSE);
    notifyCorner = settings.readNumEntry(APP_KEY + "NotifyLocation", 1);
    notifyTime = settings.readNumEntry(APP_KEY + "NotifyTimeout", 3);
    
    playlistWindow->showFilename(showFilenameOnly);
    
    //Main Window
    x = settings.readNumEntry( APP_KEY + "MainWindowX", 0 );
    y = settings.readNumEntry( APP_KEY + "MainWindowY", 0 );
    mainWindow->move( x, y );    
    r = settings.readNumEntry( APP_KEY + "LCDbgR", 178 );
    g = settings.readNumEntry( APP_KEY + "LCDbgG", 219 );
    b = settings.readNumEntry( APP_KEY + "LCDbgB", 223 );
    bg.setRgb(r,g,b);    
    r = settings.readNumEntry( APP_KEY + "LCDfgR", 0 );
    g = settings.readNumEntry( APP_KEY + "LCDfgG", 0 );
    b = settings.readNumEntry( APP_KEY + "LCDfgB", 0 );
    fg.setRgb(r,g,b);
    mainWindow->setColors(bg, fg); 
    negTime = settings.readBoolEntry( APP_KEY + "NegativeTime", FALSE);
    if(negTime) mainWindow->toggleNegTime();
    showStatus = settings.readBoolEntry( APP_KEY + "ShowStatus", FALSE);
    mainWindow->setStatusbar(showStatus);
    //Pass to options Window
    optionsWindow->recieveOptions(showFilenameOnly, showSplash, showStatus, useTray, bg, fg, refreshInt, useNotify, notifyCorner, notifyTime);   
    
    //Mini UI Window
    x = settings.readNumEntry( APP_KEY + "MiniWindowX", 0 );
    y = settings.readNumEntry( APP_KEY + "MiniWindowY", 0 );
    w = settings.readNumEntry( APP_KEY + "MiniWindowWidth", 180 );
    h = miniWindow->height();
    miniWindow->move(x,y);
    miniWindow->resize(w,h);
    
    
    //ConnectWindow
    QStringList theList;
    QString ACserver;
    QString ACpassword;
    int ACport;
    theList = settings.readListEntry( APP_KEY + "ServerList");
    ACserver = settings.readEntry( APP_KEY + "ServerAutoName", "");
    ACpassword = settings.readEntry( APP_KEY + "ServerAutoPassword", "");
    ACport = settings.readNumEntry( APP_KEY + "ServerAutoPort", 0);
    connectWindow->setList(theList);
    if(ACserver != "" && ACport != 0) {
 connectWindow->autoConnect(ACserver, ACport, ACpassword);
    }
    
    //PlaylistWindow
    x = settings.readNumEntry( APP_KEY + "PLWindowX", 0 );
    y = settings.readNumEntry( APP_KEY + "PLWindowY", 0 );
    w = settings.readNumEntry( APP_KEY + "PLWindowWidth", 400 );
    h = settings.readNumEntry( APP_KEY + "PLWindowHeight", 500 );
    playlistWindow->move(x,y);
    playlistWindow->resize(w,h);
    

    QStringList streamList;
    //BrowseWindow
    x = settings.readNumEntry( APP_KEY + "BRWindowX", 0 );
    y = settings.readNumEntry( APP_KEY + "BRWindowY", 0 );
    w = settings.readNumEntry( APP_KEY + "BRWindowWidth", 550 );
    h = settings.readNumEntry( APP_KEY + "BRWindowHeight", 575 );
    streamList = settings.readListEntry( APP_KEY + "StreamLib");
    browseWindow->setStreams(streamList);
    browseWindow->move(x,y);
    browseWindow->resize(w,h);
}



void kmpBackend::kill()
{
    this->close();
}


void kmpBackend::toggleWindow()
{
    if(showMiniW) {
 showMiniW = FALSE;
 miniWindow->hide();
 mainWindow->show();
 windowMenu->setItemChecked(windowMenu->idAt(0), TRUE);
 windowMenu->setItemChecked(windowMenu->idAt(1), FALSE);
    } else {
 showMiniW = TRUE;
 mainWindow->hide();
 miniWindow->show();
 windowMenu->setItemChecked(windowMenu->idAt(0), FALSE);
 windowMenu->setItemChecked(windowMenu->idAt(1), TRUE);
    }
}

void kmpBackend::toggleMain()
{
    if(showMiniW) {
 toggleWindow();
    } else {
 if( mainWindow->isShown()) {
     mainWindow->hide();
     windowMenu->setItemChecked(windowMenu->idAt(0), FALSE);
 } else {
     mainWindow->show();
     windowMenu->setItemChecked(windowMenu->idAt(0), TRUE);
 }
    } 
}

void kmpBackend::toggleMini()
{
    if(!showMiniW) {
 toggleWindow();
    } else {
 if(miniWindow->isShown()) {
     miniWindow->hide();
     windowMenu->setItemChecked(windowMenu->idAt(1), FALSE);
 } else {
     miniWindow->show();
     windowMenu->setItemChecked(windowMenu->idAt(1), TRUE);
 }
    }
}

void kmpBackend::mainClosed()
{
    if(useTray)
    {
 windowMenu->setItemChecked(windowMenu->idAt(0), FALSE); 
    } else {
 kill();
    }
}

void kmpBackend::miniClosed()
{
    if(useTray)
    {
 windowMenu->setItemChecked(windowMenu->idAt(1), FALSE); 
    } else {
 kill();
    }
}
void kmpBackend::trayClicked( const QPoint& at, int button)
{     
    QPoint temp = at;
    if(button == LeftButton) {
        openGUI();
    } else if(button == MidButton)  {
        sendPlay();
    }
    
}


void kmpBackend::openGUI()
{
    if(showMiniW) {
 toggleMini();
    } else {
 toggleMain();
    }
}
void kmpBackend::fixCommand()
{
    if(serverStatus == MPD_STATUS_STATE_PLAY) {
 commandMenu->changeItem(commandMenu->idAt(0), pauseI, "Pause");
    } else {
 commandMenu->changeItem(commandMenu->idAt(0), playI, "Play");
    }   
}
void kmpBackend::decrementPlaylist()
{
    curPlaylist--;
}
