/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
void kmpOptions::init()
{
    cfEdited = false;
}

void kmpOptions::recieveOptions(bool displayFilename, bool showSplash, bool showStatus, bool useTray, QColor LCDbg, QColor LCDfg, int refreshRate, bool useNotify, int notifyCorner, int notifyTime) {
    cb_useFilename->setChecked(displayFilename);
    cb_showSplash->setChecked(showSplash);
    cb_showStatus->setChecked(showStatus);
    cb_useTray->setChecked(useTray);
    LCDbg_ = LCDbg;
    color_background->setPaletteBackgroundColor(LCDbg_);
    LCDfg_ = LCDfg;
    color_foreground->setPaletteBackgroundColor(LCDfg_);
    le_refreshRate->setText(QString::number(refreshRate));
    cb_popup->setChecked(useNotify);
    cb_ntLoc->setCurrentItem(notifyCorner);
    sb_ntTm->setValue(notifyTime);
}


void kmpOptions::changeBackground()
{
    LCDbg_ = QColorDialog::getColor(LCDbg_);
    color_background->setPaletteBackgroundColor(LCDbg_);
}


void kmpOptions::changeForeground()
{
    LCDfg_ = QColorDialog::getColor(LCDfg_);
    color_foreground->setPaletteBackgroundColor(LCDfg_);
}


void kmpOptions::applyChanges()
{
    int rr = le_refreshRate->text().toInt();
    if(rr < 150) rr = 150;
    if(rr > 30000) rr = 30000;
    int cf;
    if(!( cb_crossFade->isOn())) cf = 0;
    else cf = sb_crossFade->value();
    le_refreshRate->setText(QString::number(rr));
    returnSettings(cb_useFilename->isChecked() , cb_showSplash->isChecked(), cb_showStatus->isChecked(), cb_useTray->isChecked(), LCDbg_ , LCDfg_, rr, cf, cb_popup->isOn(),  cb_ntLoc->currentItem(), sb_ntTm->value() );
}



void kmpOptions::OK()
{
    applyChanges();
    cfEdited = false;
    this->close();
}


void kmpOptions::setServerStats(QString version, QString playTime, QString uptime, QString dbTime, int artists, int albums, int songs)
{
    serverVer->setText(version);
    servUptime->setText(uptime);
    servPlayed->setText(playTime);
    dbUptime->setText(dbTime);
    artistsLabel->setText(QString::number(artists));
    albumsLabel->setText(QString::number(albums));
    songsLabel->setText(QString::number(songs));
}

void kmpOptions::setCrossfade(int time)
{
    if(!cfEdited)
    { 
        cb_crossFade->setChecked(time);
        sb_crossFade->setEnabled(time);
        sb_crossFade->setValue(time);
        tl_cf->setEnabled(time);
        tl_sec->setEnabled(time);
    }
}




void kmpOptions::cfTouched()
{
    cfEdited = true;
}


void kmpOptions::cfCheckTog( bool  value)
{
    sb_crossFade->setEnabled(value);
    sb_crossFade->setValue(1);
    tl_cf->setEnabled(value);
    tl_sec->setEnabled(value);
}
